## Overview

To fastly start an application without pain, Synaptix.js exposes a  [launchApplication](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/utilities/launchApplication.js) utility to run in your server entrypoint.

```js
import {launchApplication} from '@mnemotix/synaptix.js';
import Package from '../../package.json';
import environment from '../../config/environment';
import {generateGraphQLEndpoints} from './middlewares/generateGraphQLEndpoints';

launchApplication({
  Package,                          // (1)
  environment,                      // (2)
  generateGraphQLEndpoints,         // (3)
  launchMiddlewares: [/* ... */],   // (4)
  initMiddlewares: [/*...*/]        // (5)
})
  .then(() => {
    // Your application has started.
  })
  .catch((e) => {
    // Your application has failed.
  });
```

- (1) is the NPM `package.json` imported as JS object.
- (2) is the environment file describing required environment variables. See the following [chapter](./launching_application.md#environment-file).
- (3) is a function generating GraphQL endpoints. See the following [chapter](./launching_application.md#graphql-endpoints-generator).
- (4) and (5) are middlewares called respectively at the begining and at the end of the launching process. See the following [chapter](./launching_application.md#launch-and-init-middlewares). 

!!! note
    Note that only the first three parameters are required.
    
    
### Environment file

Environment file is an object describing required environment variables following this format :

```js
export const environment = {
  [REQUIRED_VARIABLE_NAME]: {
    description: 'Textual description of the variable',
    defaultValue: 'default_value_in_dev_mode',
    defaultValueInProduction: true  // If false and env variable not set, launch process will throw an error.
  }
}
``` 

!!! info
    A sumup of used environment variables is available in "environment" section.
    
### GraphQL endpoints generator

`#!js generateGraphQLEndpoints` parameter is a function responsible for giving the signature of GraphQL endpoints.

Here is a snippet to implement it :

```js
import {dataModel} from '../datamodel/dataModel';
import {generateDatastoreAdapater} from "./generateDatastoreAdapter"; 

/**
 * @param {ExpressApp} app - The synapix.js ExpressApp instance which will run the application server
 * @param {SSOApiClient} ssoApiClient
 * @param {SSOMiddleware[]} ssoMiddlewares
 */
export async function generateGraphQLEndpoints({app, ssoApiClient, ssoMiddlewares}) {   // (1)
  let {
    datastoreAdapter
  } = await generateDatastoreAdapater({app, ssoApiClient, ssoMiddlewares});             // (2)

  return [
    {
      endpointURI: '/graphql',                                          // (3)
      graphQLSchema: dataModel.generateExecutableSchema(),              // (4)
      datastoreAdapter,                                                 
      datastoreAdapterKey: "default",                                   // (5)
      acceptAnonymousRequest: true                                      // (6)
    }
  ];
}
```

- (1) `generateGraphQLEndpoints` will be called with two arguments. The [ExpressApp](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/utilities/ExpressApp.js) and an optional instance of [SSOApiClient](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datamodules/drivers/sso/SSOApiClient.js) and [SSOMiddleware](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datamodules/middlewares/sso/SSOMiddleware.js) list is application is securized.
- (2) `generateDatastoreAdapater` is not detailed as it already been explained in the "accessing_data" section. Just note that a GraphQLEndpoint is a data endpoint for a client, so it is attach to a [SynaptixDatastoreAdapter](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datastores/SynaptixDatastoreAdapter.js) instance. Synaptix.js is able to carry out multiple GraphQLEndpoints, with possibly multiple [SynaptixDatastoreAdapter](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datastores/SynaptixDatastoreAdapter.js) instances. 
- (3) This is the route where GraphQLEndpoint will be reached.
- (4) This is the GraphQL schema generated by a [DataModel](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datamodel/Datamodel.js). See "datamodel" section.
- (5) As multiple [SynaptixDatastoreAdapter](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datastores/SynaptixDatastoreAdapter.js) instances can live in the application, you can pass an optionnal key to retrieve it with `#!js ExpressApp::getDatastoreAdapter(key)`. This paramater is optional if only one [SynaptixDatastoreAdapter](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/datastores/SynaptixDatastoreAdapter.js) is used and `#!js ExpressApp::getDefaultDatastoreAdapter()` aims to retrieve it.
- (6) Is GraphQLEndpoint reachable with non authenticated request ?

### Launch and init middlewares

Middlewares are simple function called during the launch process to add extra logic.

#### Init middlewares

In [launchApplication](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/utilities/launchApplication.js) utility, `#!js initMiddlewares` are called like so just after the parsing of [enviroment file](./launching_application.md#environment-file)

```js
for (let initMiddleware of initMiddlewares) {                                             
  /** @param {ExpressApp} app - The application */
  await initMiddleware({app});
}
```

Feel free to add your own logic inside like init extra processes.

#### Launch middlewares

In [launchApplication](https://gitlab.com/mnemotix/synaptix.js/blob/master/src/server/utilities/launchApplication.js) utility, `#!js launchMiddlewares` are called like so just after the parsing of [enviroment file](./launching_application.md#environment-file)

```js
for (let launchMiddleware of launchMiddlewares) {
  /**
    * @param {ExpressApp} app - The application
    * @param {function} authenticate - The ExpressJS authenticate middleware used to securize routes.
    * @param {SSOApiClient} ssoApiClient - The instance of SSOApiClient 
    * @param {SSOMiddleware[]} ssoMiddlewares - The list of SSOMiddlewares 
    */
  await launchMiddleware({app, authenticate, ssoApiClient, ssoMiddlewares});
}
```

Feel free to add your own logic inside like adding business ExpressJS routes you can securize.
 